.586 
.model flat, stdcall
option casemap :none			; case sensitive 

	include windows.inc 
	include user32.inc 
	include kernel32.inc 
	include winmm.inc			; PlaySound
	include masm32.inc		; atodw
	includelib user32.lib 
	includelib kernel32.lib 
	includelib winmm.lib		; PlaySound
	includelib masm32.lib		; atodw


	WinMain PROTO :DWORD, :DWORD, :DWORD, :DWORD 
	WndProc PROTO :DWORD, :DWORD, :DWORD, :DWORD 
	EditBox PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
	FilterInput PROTO :DWORD, :DWORD, :DWORD, :DWORD
	ShowString PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
	PushButton PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD


.data
	szDisplayName	DB "Freehafer's F to C Program  2003 INNEA PUBLISHING CO.", 0 
	szMsg			DB 'You hit the right mouse button!', 0
	szDlgTitle		DB 'Freehafer''s Fahrenheit To Celsius Conversion Program Is Cool!', 0
	wave_path		DB 'roak.wav', 0
	btnClass		DB "BUTTON", 0
	ConvBut		DB "CONVERT FAHRENHEIT TO CELCIUS", 0
	ExBut			DB "EXIT", 0
	PlySnd		DB "PLAY *.WAV FILE", 0
	ExecBut		DB "EXECUTE 16 BIT VERSION", 0
	strClass		DB "STATIC", 0 
	slEdit		DB "EDIT", 0 
	szClassName		DB "Templateq", 0
	AboutMsg		DB "Assembled with MASM32.  Download it at:", 10, 13, "http://www.pbq.com.au/home/hutch/masm.htm", 10, 13, 10, 13, "Use your right mouse button outside of any message box or button for a surprise.", 0
	WhatMsg		DB "Hit any key when cursor is not in a edit or message box to stop the obnoxious beeping.", 10, 13, 10, 13, "The 16 bit executable ftc16.exe also converts F to C, and must be in same directory as this program to be started by this program.", 10, 13, 10, 13, "Enter only F from 32 up to 655350 for conversion.", 10, 13, 10, 13, "The wave file this program plays is roak.wav.  If it is not in the same directory as this program you will not hear it.", 0
	WhatTitle		DB "WHAT CAN YOU DO WITH THIS PROGRAM RK NOG?", 0
	lbl1			DB "Input degrees Fahrenheit: ", 0
	lbl2			DB "Output degrees Celcius: ", 0
	PathExecutable	DB "ftc16.exe", 0
	err_msg		DB "BAD INPUT!", 0
	warning		DB "You may only enter digits from 0 to 9!",0 
	FaEdBx		DB 0
	CeEdBx		DB 0
	CommandLine		DD 0
	hWnd			DD 0
	hInstance		DD 0
	hEdit1		DD 0
	hEdit2		DD 0
	C_NUM			DD 0
	F_NUM			DD 0
	NUMVAL		DD 0
	last_input		DD 0


.code
start:
	invoke GetModuleHandle, 0
	mov hInstance, EAX
	invoke GetCommandLine
	mov CommandLine, EAX
	invoke WinMain, hInstance, 0, CommandLine, SW_SHOWDEFAULT 
	invoke ExitProcess, EAX


WinMain proc hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD  
	LOCAL wc:WNDCLASSEX 		; put locals on stack
	LOCAL msg:MSG 			; 
	LOCAL Wwd:DWORD 			; 
	LOCAL Wht:DWORD 			; 
	LOCAL Wtx:DWORD 			; 
	LOCAL Wty:DWORD 			; 
	mov wc.cbSize, sizeof WNDCLASSEX 
	mov wc.style, CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW 
	mov wc.lpfnWndProc, offset WndProc 
	mov wc.cbClsExtra, NULL 	; 
	mov wc.cbWndExtra, NULL 	; 
	push hInst				; swap handles
	pop wc.hInstance			; swap handles
	mov wc.hbrBackground, 2		; green background color
	mov wc.lpszMenuName, NULL 	; 
	mov wc.lpszClassName, offset szClassName 
	invoke LoadIcon, hInst, 500	; icon ID for U.S. flag
	mov wc.hIcon, EAX 		; 
	invoke LoadCursor, NULL, IDC_ARROW 
	mov wc.hCursor, EAX		; 
	mov wc.hIconSm, 0 		; 
	invoke RegisterClassEx, ADDR wc 
	mov Wwd, 450 			; width
	mov Wht, 350 			; height
	mov Wtx, 50 			; right starting position
	mov Wty, 20				; down starting position 
	invoke CreateWindowEx, WS_EX_OVERLAPPEDWINDOW, ADDR szClassName, ADDR szDisplayName, WS_OVERLAPPEDWINDOW, Wtx, Wty, Wwd, Wht, NULL, NULL, hInst, NULL 
	mov hWnd, EAX			; 
	invoke LoadMenu, hInst, 600	; menu ID 
	invoke SetMenu, hWnd, EAX 	; 
	invoke ShowWindow, hWnd,SW_SHOWNORMAL 
	invoke UpdateWindow, hWnd 	; 
	StartLoop: 				; 
	invoke GetMessage, ADDR msg, NULL, 0, 0 
	cmp EAX, 0 				; 
	je ExitLoop 			; 
	invoke TranslateMessage, ADDR msg 
	invoke DispatchMessage, ADDR msg 
	jmp StartLoop 			; 
ExitLoop: 					; 
	mov EAX, msg.wParam		; 
	ret					; 
WinMain endp 				; 


WndProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD 
	.if uMsg == WM_COMMAND		; when a command is selected
		.if wParam == 1400 		; menu exit
			invoke SendMessage, hWin, WM_SYSCOMMAND, SC_CLOSE,NULL 
		.elseif wParam == 1500 		; about menu
			invoke MessageBox, hWin, ADDR AboutMsg, ADDR szDisplayName , MB_OK
		.elseif wParam == 1600 		; what menu
			invoke MessageBox, hWin, ADDR WhatMsg, ADDR WhatTitle , MB_OK  
		.endif
		.if wParam == 1900		; conversion button selected
			invoke SendMessage, hEdit1, WM_GETTEXT, 32, ADDR F_NUM	
			invoke atodw, ADDR F_NUM
			mov NUMVAL, EAX
		.IF(NUMVAL < 32 || NUMVAL > 655350)
			invoke SendMessage, hEdit2, WM_SETTEXT, 32, ADDR err_msg
			jmp skippy
		.ENDIF
			sub NUMVAL, 32			; C = (F-32)*5/9
			mov EAX, NUMVAL
			mov ECX, 5
			mul ECX
			mov ECX, 9
			mov EDX, 0				; hello division
			div ECX
			invoke dwtoa, EAX, ADDR C_NUM
			invoke SendMessage, hEdit2, WM_SETTEXT, 32, ADDR C_NUM
skippy:
			invoke SetFocus,hWin
		.endif
		.if wParam == 2000		; execute button selected
			invoke SetFocus,hWin
			invoke WinExec, ADDR PathExecutable, SW_SHOWMAXIMIZED
		.endif
		.if wParam == 2100		; exit button selected
			invoke SendMessage, hWin, WM_SYSCOMMAND, SC_CLOSE, NULL
		.endif
		.if wParam == 2200		; play sound button selected
			invoke PlaySound, ADDR wave_path, 0, SND_ASYNC 
			invoke SetFocus,hWin
		.endif
		ret
	.elseif uMsg == WM_CREATE	; things to do on creation
		invoke SetTimer, hWin, 1, 200, 0						; set timer
		invoke ShowString, ADDR lbl1, hWin, 50, 30, 200, 17, 0		; display strings
		invoke ShowString, ADDR lbl2, hWin, 50, 80, 200, 17, 0
		invoke EditBox, ADDR FaEdBx, 50, 50, 250, 23, hWin, 1700		; display edit boxes and return their handles
		mov hEdit1, EAX
		invoke EditBox, ADDR CeEdBx, 50, 100, 250, 23, hWin, 1800
		mov hEdit2, EAX
		invoke SetWindowLong, hEdit1, GWL_WNDPROC, FilterInput		; filter input
		mov last_input, EAX
		invoke PushButton, ADDR ConvBut, hWin, 100, 200, 300, 23, 1900	; display buttons	
		invoke PushButton, ADDR ExecBut, hWin, 200, 175, 200, 23, 2000
		invoke PushButton, ADDR ExBut, hWin, 300, 125, 100, 23, 2100
		invoke PushButton, ADDR PlySnd, hWin, 250, 150,150, 23, 2200
		ret											; return
	.elseif uMsg == WM_KEYDOWN								; things to do when key pressed
		invoke KillTimer, hWin, 1							; kill timer
		ret
	.elseif uMsg == WM_RBUTTONDOWN; when press right mouse button displays message box
		invoke MessageBox, 0, ADDR szMsg, ADDR szDlgTitle, MB_OK
		ret
	.elseif uMsg == WM_TIMER								; when timer on beep
		invoke MessageBeep, 0
		ret
	.elseif uMsg == WM_CLOSE
		invoke PostQuitMessage, 0
		ret
	.endif
	invoke DefWindowProc, hWin, uMsg, wParam, lParam 	; set and display default window
	ret
WndProc endp


PushButton proc lpText:DWORD, hParent:DWORD, a:DWORD, b:DWORD, wd:DWORD, ht:DWORD, ID:DWORD
	invoke CreateWindowEx, 0, ADDR btnClass, lpText, WS_CHILD or WS_VISIBLE, a, b, wd, ht, hParent, ID, hInstance, NULL
	ret
PushButton endp


ShowString proc lpText:DWORD, hParent:DWORD, a:DWORD, b:DWORD, wd:DWORD, ht:DWORD, ID:DWORD
	LOCAL hndle:DWORD
	invoke CreateWindowEx, WS_EX_LEFT, ADDR strClass, lpText, WS_CHILD or WS_VISIBLE or SS_LEFT, a, b, wd, ht, hParent, ID, hInstance, NULL
	ret
ShowString endp


EditBox proc ebszMsg:DWORD, a:DWORD, b:DWORD, wd:DWORD, ht:DWORD, hParent:DWORD, ID:DWORD
	LOCAL hndle:DWORD
	invoke CreateWindowEx, WS_EX_CLIENTEDGE, ADDR slEdit, ebszMsg, WS_VISIBLE or WS_CHILDWINDOW or ES_AUTOHSCROLL or ES_NOHIDESEL, a, b, wd, ht, hParent, ID, hInstance, NULL
	mov hndle, EAX
	ret
EditBox endp


FilterInput proc hCtl:DWORD, uMsg:DWORD, wParam :DWORD, lParam :DWORD	
	.if uMsg == WM_CHAR		; filter input
		.if wParam == 8 || (wParam >= 48 && wParam <= 57)	; acept backspace and numbers from '0' to '9'
			jmp accept_input		; 
		.endif			; 
		invoke MessageBox, hWnd, ADDR warning, ADDR err_msg , MB_OK  
		mov EAX, 0
		ret
	.endif
accept_input:
	invoke CallWindowProc, last_input, hCtl, uMsg, wParam, lParam
	ret
FilterInput endp


end start
